//
//  RegExJS.h
//  RegEx
//
//  Created by Patrick Geiller on 15/06/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <JavascriptCore/JavascriptCore.h>




@interface RegExJSController : NSObject {

	JSGlobalContextRef ctx;
	
	JSStringRef indicesScriptJS;
	JSStringRef matchScriptJS;
	JSStringRef replaceScriptJS;
}
 
 
+ (id)sharedController;

//
// Match methods
//	matches are case sensitive by default
//

// Match one and return string or null
- (id)match:(NSString*)string withPattern:(NSString*)pattern;
- (id)match:(NSString*)string withPattern:(NSString*)pattern isCaseSensitive:(BOOL)c;

// Match all and return array or null
- (id)matchAll:(NSString*)string withPattern:(NSString*)pattern;
- (id)matchAll:(NSString*)string withPattern:(NSString*)pattern isCaseSensitive:(BOOL)c;

// Replace all
- (id)replace:(NSString*)string withString:(NSString*)replacement andPattern:(NSString*)pattern;
- (id)replace:(NSString*)string withString:(NSString*)replacement andPattern:(NSString*)pattern isCaseSensitive:(BOOL)c;

// Match all and return indices matched in string : [[start1, end1], [start2, end2], …] 
- (id)indicesFromMatching:(NSString*)string withPattern:(NSString*)pattern;

@end

@interface NSString(RegExViaJavascriptCore)

// Match one  and return string or null
- (id)matchWithPattern:(NSString*)pattern;
- (id)matchWithPattern:(NSString*)pattern isCaseSensitive:(BOOL)c;

// Match all and return array or null
- (id)matchAllWithPattern:(NSString*)pattern;
- (id)matchAllWithPattern:(NSString*)pattern isCaseSensitive:(BOOL)c;

// Replace all
- (id)replaceWithString:(NSString*)replacement andPattern:(NSString*)pattern;
- (id)replaceWithString:(NSString*)replacement andPattern:(NSString*)pattern isCaseSensitive:(BOOL)c;

@end

